Subject: Re: [PATCH 1.8.0] add: make "add -u" update full tree without pathspec

From: Matthieu Moy <[email-masked]>
Date: Tue, 01 Mar 2011 19:51:38 +0100

Junio C Hamano <[email-masked]> writes:

> Matthieu Moy <[email-masked]> writes:
>
>> I think promoting "git add -u ." more than a configuration option would
>> reduce the pain.
>
> Yeah, I tend to agree.
>
>> As a user, if I get used to typing "git add -u ." instead of "git add -u", 
>> I get the current behavior regardless of the version of Git, without a
>> warning. Later, when all the machines I word on support the tree-wide
>> "git add -u" (either 1.7.x + some configuration or 1.8.y), I'll use it
>> as a new feature.
>
> Once your users (you as a script writer) have an option to set the
> configuration to participate in the tree-wide party early, you would need
> to update your scripts immediately so that they don't break on them;

But "update" should mean "replace git add -u with git add -u .", which
is the portable way to do the same.

> so the introduction of the configuration becomes a flag-day event.
> Hmph...

The introduction of the config variable is a non-event if you already
use the portable . notation.

>> So, a warning like
>>
>>   warning: the behavior of "git add -u" without pathspec will change in
>>   Git 1.8.0. To keep the current behavior, use this instead:
>>   
>>       git add -u .
>>   
>>   + explanations about the config options as already discussed here
>>
>> would be fine.
>
> Yeah, I think you convinced me that an elaborate configuration wouldn't
> help us at all.  We just keep warning in 1.7.x series when "add -u" didn't
> see any pathspec, and flip the default at 1.8.0
>
> Simpler and cleaner ;-)

I think is still makes sense to have a config variable, so that people
who want the new behavior can get it ASAP. Right after 1.8 is out, I'll
still have machines where I'm too lazy to install a brand new Git, and
I'll want to get the 1.8 goodness for free ;-).

-- 
Matthieu Moy
http://www-verimag.imag.fr/~moy/